package CSVDataImExporter::CMS;

use strict;
use warnings;

use base 'Exporter';
our @EXPORT_OK = qw( rest_day is_limit );

sub add_script {
    my ($cb, $app, $tmpl) = @_;

    my $old = <<HERE;
  </mtapp:settinggroup>
</form>
HERE

    my $new .= <<HERE;
  </mtapp:settinggroup>
</form>
<div style="margin-top:20px">
<mt:var name="rest_day">
</div>
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
</script>
HERE
    $old = quotemeta($old);

    $new = <<HERE;
jQuery(function(){
    change_form();
    change_button();
    jQuery('select[name=import_type]').change(function(){
        change_form();
        change_button();
    });
});
function change_form() {
    if ( jQuery('select[name=import_type] option:selected').val() == 'import_csv' ) {
        jQuery('#import_as_me-field').hide();
        jQuery('#convert_breaks-field').hide();
        jQuery('#encoding-field').hide();
        jQuery('#default_cat_id-field').hide();
    } else {
        jQuery('#import_as_me-field').show();
        jQuery('#convert_breaks-field').show();
        jQuery('#encoding-field').show();
        jQuery('#default_cat_id-field').show();
    }
}
function change_button() {
HERE

if ( is_limit() ) {
    $new .= <<HERE;
    if ( jQuery('select[name=import_type] option:selected').val() == 'import_csv' ) {
        jQuery('button').hide();
    } else {
        jQuery('button').show();
    }
HERE
}

    $new .= <<HERE;
}
</script>
HERE

    $$tmpl =~ s/$old/$new/;

}

sub add_param {
    my ($cb, $app, $param, $tmpl) = @_;

    my $plugin = MT->component("CSVDataImExporter");
    $param->{rest_day} = $plugin->translate('can use [_1]', rest_day());

    1;
}

sub init_request {
    my $plugin = MT->component("CSVDataImExporter");
    my $csv_column = $plugin->get_config_value('csv_column', 'system') || ',';
    if ($csv_column eq ',') {
        $plugin->set_config_value('csv_column', time(), 'system');
    }
}

sub is_limit {
    return (rest_day() > 0) ? 0 : 1;
}

sub rest_day {
    my $plugin = MT->component("CSVDataImExporter");
    my $csv_column = $plugin->get_config_value('csv_column', 'system') || '';
    my $duration = time() - $csv_column;
    my $rest_day = 15 - int($duration / (24 * 3600));
    return ($rest_day > 0) ? $rest_day : 0;
}

1;
